#include "stdafx.h"
#include "ActiveX_Test.h"
#include "comcat.h"
#include "strsafe.h"
#include "objsafe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CActiveX_TestApp theApp;

const GUID CDECL BASED_CODE _tlid = { 0x26A5E372, 0x7A7, 0x46E4, { 0xBA, 0x4, 0x38, 0xC, 0xD6, 0x18, 0x51, 0x48 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;
const CATID CLSID_SafeItem ={ 0x6bb75de5, 0xfb03, 0x408f, {0x99, 0xc8, 0x57, 0x3d, 0x43, 0x3e, 0x4d, 0x82}};
BOOL CActiveX_TestApp::InitInstance()
{
	BOOL bInit = COleControlModule::InitInstance();
	if (bInit){}
	return bInit;
}
int CActiveX_TestApp::ExitInstance(){
	return COleControlModule::ExitInstance();
}
HRESULT CreateComponentCategory(CATID catid, WCHAR *catDescription){
    ICatRegister *pcr = NULL ;
    HRESULT hr = S_OK ;
    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr,NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
    if (FAILED(hr)) return hr;
	CATEGORYINFO catinfo;
    catinfo.catid = catid;
    catinfo.lcid = 0x0409;
    size_t len;
	hr = StringCchLength(catDescription, STRSAFE_MAX_CCH, &len);
    if (SUCCEEDED(hr))
        {
        if (len>127)
          {
            len = 127;
          }
        }  
    else{}
    hr = StringCchCopy(catinfo.szDescription, len + 1, catDescription);
    catinfo.szDescription[len + 1] = '\0';
    hr = pcr->RegisterCategories(1, &catinfo);
    pcr->Release();
    return hr;
}
HRESULT RegisterCLSIDInCategory(REFCLSID clsid, CATID catid){
    ICatRegister *pcr = NULL ;
    HRESULT hr = S_OK ;
    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr,NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
    if (SUCCEEDED(hr)){
       CATID rgcatid[1] ;
       rgcatid[0] = catid;
       hr = pcr->RegisterClassImplCategories(clsid, 1, rgcatid);
    }
    if (pcr != NULL)pcr->Release();
    return hr;
}
HRESULT UnRegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
{
    ICatRegister *pcr = NULL ;
    HRESULT hr = S_OK ;
    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr,NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
    if (SUCCEEDED(hr))
    {
       CATID rgcatid[1] ;
       rgcatid[0] = catid;
       hr = pcr->UnRegisterClassImplCategories(clsid, 1, rgcatid);
    }
    if (pcr != NULL)pcr->Release();
    return hr;
}
STDAPI DllRegisterServer(void)
{
	HRESULT hr;   
	AFX_MANAGE_STATE(_afxModuleAddrThis);
	if (!AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid))return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(TRUE))return ResultFromScode(SELFREG_E_CLASS);
	hr = CreateComponentCategory(CATID_SafeForInitializing,L"Controls safely initializable from persistent data!");
	if (FAILED(hr))return hr;
	hr = RegisterCLSIDInCategory(CLSID_SafeItem,CATID_SafeForInitializing);
	if (FAILED(hr))return hr;
	hr = CreateComponentCategory(CATID_SafeForScripting,L"Controls safely  scriptable!");
	if (FAILED(hr))return hr;
	hr = RegisterCLSIDInCategory(CLSID_SafeItem,CATID_SafeForScripting);
	if (FAILED(hr))return hr;
	return NOERROR;
}
STDAPI DllUnregisterServer(void)
{
	HRESULT hr;   
	AFX_MANAGE_STATE(_afxModuleAddrThis);
	if (!AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor))return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(FALSE))return ResultFromScode(SELFREG_E_CLASS);
	hr=UnRegisterCLSIDInCategory(CLSID_SafeItem,CATID_SafeForInitializing);
    if (FAILED(hr))return hr;
    hr=UnRegisterCLSIDInCategory(CLSID_SafeItem,CATID_SafeForScripting);
    if (FAILED(hr))return hr;
	return NOERROR;
}
